<template>
    <v-row>

        <v-col>
            <data-table
                v-model="items"
                :title="$tc('subscription',2)"
                endpoint="api/subscriptions"
                :filters="filters"
                :headers="headers"
                :search-label="searchLabel"
            >
                <template v-slot:buttons>
                    <download-excel
                        :data="items"
                        :fields="excelFields"
                        :name="excelName"
                        type="xls"
                    >
                        <v-btn class="primary">
                            <v-icon>mdi-download</v-icon>
                            {{ $t('excel') }}
                        </v-btn>
                    </download-excel>
                </template>
                <template v-slot:filters="{ filters , confirmed }">
                    <subscription-filters
                        :dates.sync="filters.date"
                        @confirmed="confirmed"
                    ></subscription-filters>
                </template>

                <template v-slot:item="{ item }">
                    <tr>
                        <td>{{ item.user.profile.name }}</td>
                        <td>{{ item.user.email }}</td>
                        <td>{{ item.user.profile.mobile }}</td>
                        <td>{{ item.created_at | date('Do MMM YYYY') }}</td>
                        <td>{{ item.next_cycle_date | date('Do MMM YYYY') }}</td>
                        <td>{{ item.plan.name}}</td>
                        <td>{{ item.stripe_status}}</td>
                    </tr>
                </template>
            </data-table>
        </v-col>
    </v-row>
</template>

<script>
    import DataTable from "../DataTable";
    import VCountrySelect from "../VCountrySelect";
    import VRoleSelect from "../VRoleSelect";
    import util from "../../../mixins/util";
    import SubscriptionFilters from "../filters/SubscriptionFilters";
    import moment from "moment"

    export default {
        name: "Subscriptions",
        components: {SubscriptionFilters, VRoleSelect, VCountrySelect, DataTable},
        mixins: [ util ],
        data: () => ({
            filters: {
                date: []
            },
            items: []
        }),

        computed: {
            excelFields() {
                return {
                    'Name': 'user.profile.name',
                    'Email': 'user.email',
                    'Mobile': 'user.profile.mobile',
                    'Date Subscription': {
                        field : 'created_at',
                        callback: (value) => {
                            return moment(value).format('YYYY-MM-DD HH:mm:ss');
                        }
                    },
                    'Cycle Date': {
                        field : 'next_cycle_date',
                        callback: (value) => {
                            return moment(value).format('YYYY-MM-DD HH:mm:ss');
                        }
                    },
                    'Plan': 'plan.name'}
            },

            excelName() {
                let currentTime = moment().format('YYYY_MM_DD');
                return 'Subscription_'+currentTime+'.xls';
            },
            headers() {
                return [
                    { text: this.$t('name'), value: 'name' },
                    { text: this.$t('email'), value: 'email' },
                    { text: this.$t('mobile'), value: 'mobile' },
                    { text: this.$t('date_subscription'), value: 'created_at'},
                    { text: this.$t('cycle_date'), value: 'cycle_date'},
                    { text: this.$t('plan'), value: 'plan'},
                    { text: this.$t('stripe_status'), value: 'stripe_status'},
                ]
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('name')
                })
            }
        }
    }
</script>

<style scoped>
</style>
